<?
require ('cfg/db.php');
?>

<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title><?php echo $px_name; ?> - Make Tables</title>
<link rel="stylesheet" type="text/css" href="site.css"/>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
</head>
<body>
<div class="mbody">

<?
db_connect($dbhost, $dbuser, $dbpass);

// create table to manage files
$sql = 'CREATE TABLE px_files (
		FileID INT(8) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		PaperID INT(8),
		DownloadCount INT(8) NOT NULL DEFAULT 0,
		FileName TINYTEXT,
		FileSize INT,
		FileType TINYTEXT,
		DateAdded DATETIME,
		UploadedBy TINYTEXT,
		FileTitle TINYTEXT,
		Note TINYTEXT
		)';

if (@mysql_query($sql)) {
	echo 'Files successfully created.<br/><br/>';
}

else {
	die('Error creating front page data table.  MySQL error message:<br/><br/>' . mysql_error());
	}

// create user table
$sql = 'CREATE TABLE px_users (
			UserID INT(8) NOT NULL AUTO_INCREMENT PRIMARY KEY,
			Username varchar(20) NOT NULL UNIQUE,
			Password varchar(32) NOT NULL,
			Fullname varchar(35),
			Email varchar(60),
			Profile TEXT,
			PaperCount INT(5),
			PostCount INT(6),
			RandomSeed TINYTEXT,
			UserPermissions INT(3) ZEROFILL NOT NULL,
			CreateDate DATETIME NOT NULL,
			LastVisited DATETIME
			)';

if (@mysql_query($sql)) {
	echo 'User table successfully created.<br/><br/>';
}

else {
	die('Error creating table.  MySQL error message:<br/><br/>' . mysql_error());
	}

// create categories table
$sql = 'CREATE TABLE px_categories (
		ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		Category TINYTEXT NOT NULL,
		CategoryID VARCHAR(10) NOT NULL UNIQUE,
		Overview TEXT
		)';

if (@mysql_query($sql)) {
	echo('Categories table successfully created.<br/><br/>');
	}
else {
	die('Error creating table.  MySQL error message:<br/><br/>' . mysql_error());
	}

// create papers table
$sql = 'CREATE TABLE px_papers (
		PaperID INT(8) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		PaperTitle TEXT,
		Abstract TEXT,
		Citation TEXT,
		SubmittedBy varchar(20),
		UpdatedBy varchar(20),
		CategoryID VARCHAR(10),
		Links TEXT,
		Notes TEXT,
		DateSubmitted DATETIME,
		DateModified DATETIME
		)';

if (@mysql_query($sql)) {
	echo('Papers table successfully created.<br/><br/>');
	}
else {
	die('Error papers creating table.  MySQL error message:<br/><br/>' . mysql_error());
}

// create table for discussion data
$sql = 'CREATE TABLE px_posts (
		PostID INT(8) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		ThreadID INT(8) NOT NULL,
		Poster varchar(20),
		Post TEXT,
		PostSubject varchar(60),
		PostTime DATETIME,
		PostEdit DATETIME
		)';

if (@mysql_query($sql)) {
	echo('Posts table successfully created.<br/><br/>');
	}
else {
	die('Error creating posts table.  MySQL error message:<br/><br/>' . mysql_error());
}

// create table to handle 'threads' of discussion data
$sql = 'CREATE TABLE px_threads (
		ThreadID INT(8) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		PaperID INT(8) NOT NULL,
		LastPost DATETIME,
		LastPoster varchar(20),
		Subject varchar(60),
		PostCount INT(6),
		PostDate DATETIME,
		InitPostID INT(8),
		ThreadStatus INT(3) NOT NULL DEFAULT 111
		)';

if (@mysql_query($sql)) {
	echo('Threads table successfully created.<br/><br/>');
	}
else {
	die('Error creating threads table.  MySQL error message:<br/><br/>' . mysql_error());
}

// create default user
$ipass = md5('k87132');
$sql = "INSERT INTO px_users SET
		username = 'biocomplexity',
		password = '$ipass',
		fullname = 'administrator',
		email = 'none@null.com',
		CreateDate = NOW()";
		
if (@mysql_query($sql)) {
	echo "User added successfully!<br/><br/>";
	}

else {
	die('Error adding data.<br>' . mysql_error());
	}

?>

</div>

</body>
</html>