<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/db_functions.php');

$table = 'px_papers';

$login_flag = sess_check();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Add Paper</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js">
</script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body>
<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>
<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="header3">Add Paper</div>

<?php
//
// Check for log-in before displaying page;
// 
if ($login_flag == 1) {
	//
	// Additional Verification if Logged In
	//
	if($_SESSION['permissions'][0] >= 1 OR $_SESSION['permissions'][1] >= 1) {
	// contine
	}
	else {
	p_error();
		}
	}
else {
	echo 'You must be logged-in to add papers.';
	p_error();
}


//
// Add paper if data is submitted, after verification.
//
if(isset($_POST['submit_paper'])){


db_connect($dbhost, $dbuser, $dbpass);
$PaperTitle = trim(add_slashes($_POST['PaperTitle']));
$Abstract = trim(add_slashes($_POST['Abstract']));
$Citation = trim(add_slashes($_POST['Citation']));
$Notes = trim(add_slashes($_POST['Notes']));
$SubmittedBy = $_POST['SubmittedBy'];

if($_SESSION['user'] != $SubmittedBy) {
echo 'Error.';
p_error();
}

if ($Abstract == '') {
$Abstract = 'No abstract is presently available for this paper.';
}
$sql = "INSERT INTO $table SET
		PaperTitle = '$PaperTitle',
		Abstract = '$Abstract',
		Citation = '$Citation',
		SubmittedBy = '$SubmittedBy',
		UpdatedBy = '$SubmittedBy',
		Notes = '$Notes',
		DateSubmitted = NOW(),
		DateModified = NOW()";

if (@mysql_query($sql)) {
	echo '<div class="papers1">Data added successfully!<br /><br />
	<a href="browse.php?action=view&pid=' . mysql_insert_id() .'">Click here</a> to view the data that have been submitted.  To add files, links, or modify the data, <a href="edit.php?action=edit&pid=' . mysql_insert_id() . '">go here</a>.<br /><br />
	<a href="add.php">&lt; Back to Add Paper Page</a></div>';
	}

else {
	die('Error adding data.<br>' . mysql_error() . '<br/><br/>');
}

db_increment_count('px_users', 'Username', $SubmittedBy, 'PaperCount', 1);

mysql_close();
}

else {
echo '<form action="add.php" name="paper" method="post" onsubmit="return checkPaperForm()"> 

Paper Title:<br/> <span style="margin-left: 30px;"><input type="text" name="PaperTitle" size="60" maxlength="2048" value="" /></span><br/><br/>

Paper Abstract: <br />
<span style="margin-left: 30px;"><textarea name="Abstract" rows="18" cols="50" maxlength="16348" wrap="virtual"></textarea></span><br /><br />

Paper Citation: <br />
<span style="margin-left: 30px;"><textarea name="Citation" rows="8" cols="50" wrap="virtual"></textarea></span><br /><br />

Additional Notes: <br />
<span style="margin-left: 30px;"><textarea name="Notes" rows="5" cols="50" wrap="virtual"></textarea></span><br /><br />

Submitted By: <input type="hidden" name="SubmittedBy" value="' . $_SESSION['user'] . '">' . $_SESSION['user'] . '<br/><br/>

Added: ' . date('d F Y H:i') . '<br /><br />

Files & Links may be added later by editing this paper\'s record.<br /><br/><br/>

<input type="submit" name="submit_paper" value="Add Paper" />
<input type="reset" name="clear" value="Clear" />
</form>';
}

//
// END CODE
//

include('includes/px_bottom.php');
?>
<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 


</td></tr></table>

</body>
</html>