<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
require('cfg/pagination_sort.php');
header("Pragma: no-cache");

$table = 'px_posts';

$login_flag = sess_check();

//
// functions specific to this page
// 
function preview_post($subject, $message) {
global $forum_date;

echo '<table class="post">
<tr id="theader">
	<td colspan="2">Preview Post</td>
</tr>
<tr id="row1">
	<td id="postLeft"><strong>' . $_SESSION['user'] .  '</strong></td>
	<td>
	
	<table>
	<tr>
	<td id="postInfo">'; 
	if($subject != '') { echo '<strong>Subject:</strong> ' . $subject . '<br />'; } 
	
	echo '
	posted on ' . date($forum_date) . '</td></tr>
	<tr><td>' .
	parse_html($message) .
	'</td></tr></table>
	
	</td>
</tr>
</table><br /><br /><br />';
}

function forum_ht($pid, $tid) {
echo '<div align="right">
<a href="post.php?action=thread&pid=' . $pid . '"><img src="images/forum_new_topic.gif" alt="Add New Topic" border="0" /></a> &nbsp;
<a href="post.php?action=post&tid=' . $tid . '"><img src="images/forum_post_reply.gif" alt="Add Post Reply" border="0" /></a> &nbsp;</div><br />';
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Discussion</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js">
</script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>
<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Discussion</div>

<?php
db_connect($dbhost, $dbuser, $dbpass);

//
// use a switch on 'action' if specified
//
if(isset($_GET['action'])) {

//
// get data to generate navigation
//

switch($_GET['action']) {

//
// view a thread
//	
	case 'view':
	if(!isset($_GET['tid'])) {
	echo 'No thread specified.';
	p_error();
	}

	$tid = $_GET['tid'];

	$sql = "SELECT PostCount, Subject, PaperID FROM px_threads WHERE ThreadID = $tid";
	if(!$tdata = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid thread ID specified.';
	p_error();
	}
	
	$paperID = $tdata[2];
	
	$sql = "SELECT PaperTitle FROM px_papers WHERE PaperID = $paperID";
	@$pdata = mysql_fetch_row(mysql_query($sql));
	
	$title = $pdata[0];

	// display navigation
	echo '<a href="discuss.php?action=paper&pid=' . $paperID . '">Discussions</a> for Paper \'' . truncate($title, 35) . '\' &gt; Thread: \'' . $tdata[1] . '\'';

	// pagination variables
	if(!isset($_GET['pg'])) {
	$page = 1;
	}
	else {
	$page = $_GET['pg'];
	}
	$pvars = page_vars($tdata[0], $forum_per_page, $page);


	$sql = mysql_query("SELECT Poster, Post, PostSubject, DATE_FORMAT(PostTime, '$date_time_short'), PostID FROM $table WHERE ThreadID = $tid ORDER BY PostTime ASC LIMIT " . $pvars['start'] . ", $forum_per_page");

	
	// display data
forum_ht($paperID, $tid);

//<br />' . $tdata[0] . ' posts in thread.  Viewing posts ' . ($pvars['start']+1) . ' through ' . ($pvars['end']+1) . '.<br />
echo '<span class="forumNavi">';
generate_navigation ($pvars['num_pages'], $pvars['page'], 'discuss.php?action=view&tid=' . $tid . '&');
echo '</span>

<table class="post">
<tr id="theader">
	<td colspan="2">Thread: ' . $tdata[1] . ' / page: ' . $pvars['page'] .  '</td>
</tr>';

$count = 0;
	while($row = mysql_fetch_row($sql)) {
	if($count % 2) {
	echo '<tr id="row2">';
	}
	else {
	echo '<tr id="row1">';
	}
	
	// body of post	
	echo '<td id="postLeft"><a name="p' . $row[4] .'"></a><strong>' . $row[0] .  '</strong></td>
	<td>
	
	<table class="innerPost">
	<tr>
	<td id="postInfo">'; 
	if($row[2] != '') { echo '<strong>Subject:</strong> ' . parse_html($row[2]) . ' / '; } 
	
	echo '
	posted on ' . $row[3] . '</td></tr>
	<tr><td>' .
	parse_html($row[1]) .
	'</td></tr><tr><td>
	<a href="users.php?user=' . $row[0] . '"><img src="images/forum_userinfo.gif" alt="Userinfo" title="Click to get the user information of user ' . $row[0] . '" border="0" /></a>
	<a href="post.php?action=post&tid=' . $tid  . '&replyto=' . $row[4] . '"><img src="images/forum_reply.gif" alt="Reply" title="Click to reply to this message" border="0" /></a>
	<a href="post.php?action=edit&pid=' . $row[4] . '"><img src="images/forum_edit.gif" alt="Edit" title="Click to edit this post" border="0" /></a>
	</td></tr>
	</table>
	
	</td>
	</tr>';

	$count++;
	}

	echo '</table><br />';
echo '<span class="forumNavi">';
generate_navigation ($pvars['num_pages'], $pvars['page'], 'discuss.php?action=view&tid=' . $tid . '&');
echo '</span><br />';

forum_ht($paperID, $tid);
	break;

//
// paper - display discussions for a particular paper
//

	case 'paper':
	if(!isset($_GET['pid'])) {
	echo 'No paper ID specified.';
	p_error();
	}
	else {
	$pid = $_GET['pid'];
	validate_id($pid);
	}

	$sql = mysql_query("SELECT PaperTitle from px_papers WHERE PaperID = $pid");
	if(!$pdata = mysql_fetch_row($sql)) {
	echo 'Invalid paper ID specified.';
	p_error();
	}

	
	echo '<a href="browse.php?action=view&pid=' . $pid . '">Paper \'' . truncate($pdata[0], 35) . '\'</a> &gt; Discussions<br /><br />';
	
	
	// allow user to start discussion if there are none; otherwise, display them and also allow user to start a new one
	$sql = mysql_query("SELECT ThreadID from px_threads WHERE PaperID = $pid");
	
	if(!mysql_fetch_row($sql)) {
	echo 'There are no current discussions for this paper.  <a href="post.php?action=thread&pid=' . $pid . '">Start one</a>.<br />';
	}
	else {

	$data = mysql_query("SELECT ThreadID, Subject, DATE_FORMAT(LastPost, '$date_time_short'), LastPoster, PostCount FROM px_threads  WHERE PaperID = $pid ORDER BY LastPost DESC");

	echo '<a href="post.php?action=thread&pid=' . $pid . '"><img src="images/forum_new_topic.gif" alt="Add New Topic" border="0" /></a><br />
	<table class="post">
	<tr id="theader">
	<td>Subject</td>
	<td>Posts</td>
	<td>Last Post by</td>
	</tr>';
	
	while($row = mysql_fetch_row($data)) {
		echo '<tr>
		<td id="row1"><a href="discuss.php?action=view&tid=' . $row[0] . '">' . htmlspecialchars($row[1], ENT_NOQUOTES) . '</a></td>
		<td id="row2">' . $row[4] . '</td>
		<td id="row1">' . $row[3] . ', ' . $row[2] . '</td>
		</tr>';	
		
		}
	echo '</table>';
	
	}
	
			
	break;

	default:
	echo 'No function specified.';
	break;
	
	}
// end switch
}
// end if

//
// otherwise display the error message:
//
else {

echo 'No action specified.';

}
// end else

include('includes/px_bottom.php');
?>
</div>

<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 

</td></tr></table>

</body>
</html>