<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
header("Pragma: no-cache");

$table = 'px_papers';

$login_flag = sess_check();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Edit Paper</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js"></script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>

<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Edit Paper</div>

<?php
//
// Check for log-in before displaying page;
// 
if ($login_flag == 1) {
// Initialize Database Connection
db_connect($dbhost, $dbuser, $dbpass);
}
else {
p_error();
}



//
// Depending on permissions, set page flag to display a different version of the page.
//

if ($_SESSION['permissions'][0] >= 1) {
$page = 'admin';
}
elseif($_SESSION['permissions'][1] >= 1) {
$page = 'user';
}
else {
// Otherwise, error and prevent page from being displayed
p_error();
}

//
// If user submits paper to edit, edit it!
//
if(isset($_POST['edit_paper'])){

// variables that both delete and edit functions will use

$pid = trim($_POST['pid']);
$UpdatedBy = trim(add_slashes($_POST['UpdatedBy']));
$SubmittedBy = trim(add_slashes($_POST['SubmittedBy']));

papers_auth($UpdatedBy);
validate_id($pid);

// Delete the Paper if Deletion has been Requested
if(isset($_POST['dflag']) && isset($_POST['dflag_confirm']) && $_POST['dflag'] == 'd00' && $_POST['dflag_confirm'] == 'd01') {

	// attempt to remove files, if they exist
	$numRows = db_get_record_count_select('px_files', 'FileID', 'PaperID', $pid);

	if ($numRows == 0) {
	// skip and continue
	}

	else {
	$files = array();
	$x = 0;
	
	// get file names
	$sql = mysql_query("SELECT FileName FROM px_files WHERE PaperID = '$pid'");
	while ($row = mysql_fetch_row($sql)) {
	$files[$x] = $row[0];
	$x++;	
	}
	
	for ($x = 0; $x < sizeof($files); $x++) {
	$file = $uploaddir . '/' . $files[$x];
	if(!unlink($file)) {
	echo 'Error deleting ' . $file . '<br />
	Please notify an administrator of this and include all error information.<br /><br />';
	p_error();
		}
	}
	
	$sql = "DELETE FROM px_files WHERE PaperID = '$pid'";
	if(!@mysql_query($sql)) {
	echo 'Error deleting file data from the database.  Please notify an administrator of this error.<br /><br />';
	}
	
	// attempt to remove discussions
	
	
	
	// then delete record from database
	$sql = "DELETE FROM $table WHERE PaperID = '$pid'";
	if(!@mysql_query($sql)) {
	echo 'Error deleting paper from the database.  Please send this information to an administrator:<br />
	Deleteion Request - Paper ID: ' . $pid . '<br /><br />';
	}
	else {
	echo 'Paper sucessfully deleted!<br />
	<a href="/">Back to main page</a>';
		}	
	
	db_increment_count('px_users', 'Username', $SubmittedBy, 'PaperCount', -1);
	
	}
}

else {

$PaperTitle = trim(add_slashes($_POST['PaperTitle']));
$Abstract = trim(add_slashes($_POST['Abstract']));
$Citation = trim(add_slashes($_POST['Citation']));
$Notes = trim(add_slashes($_POST['Notes']));

// get links into an array
// first, break each link 
$Links = array();
for($x = 1; $x <= 5; $x++) {

$var = array('link' . $x, 'linktitle' . $x, 'linkdesc' . $x);
$eachLink = array();

if(isset($_POST[$var[0]]) && $_POST[$var[0]] != '') {

	if(!validate_url($_POST[$var[0]])) {
	echo 'Link No ' . $x . ' was invalid and was not saved.  Please enter the full URL, including the protocol (http://, ftp://, et al.).  Continuing...<br /><br />';
	continue;
	}
	
	for($z = 0; $z <= 2; $z++) {
	$eachLink[$z] = substr(trim($_POST[$var[$z]]), 0, 512);
	}
	
	$Links[$x] = implode(',', $eachLink);
	}

}

$LinksData = implode('|', $Links);

// update the table

$sql = "UPDATE $table SET
		PaperTitle = '$PaperTitle',
		Abstract = '$Abstract',
		Citation = '$Citation',
		Notes = '$Notes',
		UpdatedBy = '$UpdatedBy',
		Links = '$LinksData',
		DateModified = NOW()
		WHERE PaperID = '$pid'";

if(!mysql_query($sql)) {
echo 'Error - database error or invalid paper ID specified.<br /><br />' . mysql_error();
}
else {
echo 'Data successfully edited.<br />
<a href="browse.php?action=view&pid=' . $pid .'">View</a> paper data.  <a href="edit.php?pid=' . $pid . '">Edit</a> the data again.<br /><br />';
}
}


}

//
// Else if the user specifies a record to edit;
//
elseif(isset($_GET['pid'])) {

$pid = trim($_GET['pid']);

validate_id($pid);

echo '| <a href="#paper">Edit Paper</a> | <a href="#links">Modify Links</a> | <a href="#files">Manage Files</a> |<br /><br />';

$sql = "SELECT PaperTitle, Abstract, Citation, Notes, SubmittedBy, UpdatedBy, Links FROM $table WHERE PaperID = '$pid'";
$row = mysql_fetch_row(mysql_query($sql));

if(mysql_num_rows(mysql_query("SELECT PaperTitle FROM $table WHERE PaperID = '$pid'")) == 0) {
echo 'Invalid Paper ID specified.';
p_error();
}

//
// Ensure that the user is a person who is authorized to edit the record: either the user who posted it or an administrator
//
papers_auth($row[4]);

//
// Otherwise display the page
//

echo '<a name="paper"></a>
<form action="edit.php" name="paper" method="post" onsubmit="return checkPaperForm()"> 

Paper Title:<br/> <span style="margin-left: 30px;"><input type="text" name="PaperTitle" size="60" maxlength="2048" value="' . $row[0] . '" /></span><br/><br/>

Paper Abstract: <br />
<span style="margin-left: 30px;"><textarea name="Abstract" rows="18" cols="50" maxlength="16348" wrap="virtual">' . $row[1] . '</textarea></span><br /><br />

Paper Citation: <br />
<span style="margin-left: 30px;"><textarea name="Citation" rows="8" cols="50" wrap="virtual">' . $row[2] . '</textarea></span><br /><br />

Additional Notes: <br />
<span style="margin-left: 30px;"><textarea name="Notes" rows="5" cols="50" wrap="virtual">' . $row[3] . '</textarea></span><br /><br />


Submitted By: <input type="hidden" name="SubmittedBy" value="' . $row[4] . '" />' . $row[4] . '<br/><br/>
Last Modified By: ' . $row[5] . '<br />
Current User: <input type="hidden" name="UpdatedBy" value="' . $_SESSION['user'] . '" />' . $_SESSION['user'] . '<br/><br/>
Date &amp; Time: ' . date('d F Y H:i') . '<br /><br />
<input type="hidden" value=" ' . $pid . '" name="pid" />';

// links

echo '<img src="images/bpixel.gif" width="500" height="1" alt="- - -" /><br />
<a name="links"></a><span class="header3">Links</a></span><br /><br />';

//
// if links exist, then parse them and display them, otherwise display space for user to add links
//
$y = 8;

if ($row[6] == '') {
echo 'No links currently entered.  Add links below.<br />';

for ($x = 1; $x <= 5; $x++) {
echo '
Link No ' . $x . ' - <input type="checkbox" name="cbox_link' . $x . '" onclick="toggleLink(' . $y . ')"> Check to <strong>add</strong><br />
<div style="margin-left: 30px; line-height: 25px;">
URL: <input type="text" name="link' . $x . '" maxlength="350" disabled="true" /><br />
Title: <input type="text" name="linktitle' . $x . '" maxlength="128" disabled="true" /><br />
Description: <input type="text" name="linkdesc' . $x . '" maxlength="255" disabled="true" /></div><br />';
$y += 4;
	}
}

// if links have been entered
else {
echo 'Links have been entered: edit or delete links below.<br />';

$links = explode('|', $row[6]);

$max = sizeof($links);

for ($x = 1; $x <= $max; $x++) {

$eachLink = explode(',', $links[$x-1]);
echo '
Link No ' . $x . ' - <input type="checkbox" name="cbox_link' . $x . '" onclick="toggleLink(' . $y . ')"> Check to <strong>delete</strong><br />
<div style="margin-left: 30px; line-height: 25px;">
URL: <input type="text" name="link' . $x . '" maxlength="350" value="' . $eachLink[0] . '" /><br />
Title: <input type="text" name="linktitle' . $x . '" maxlength="128" value="' . $eachLink[1] . '" /><br />
Description: <input type="text" name="linkdesc' . $x . '" maxlength="255" value="' . $eachLink[2] . '" /></div><br />';
$y += 4;
}


for ($x = $max+1; $x <= 5; $x++) {
echo '
Link No ' . $x . ' - <input type="checkbox" name="cbox_link' . $x . '" onclick="toggleLink(' . $y . ')"> Check to <strong>add</strong><br />
<div style="margin-left: 30px; line-height: 25px;">
URL: <input type="text" name="link' . $x . '" maxlength="350" disabled="true" /><br />
Title: <input type="text" name="linktitle' . $x . '" maxlength="128" disabled="true" /><br />
Description: <input type="text" name="linkdesc' . $x . '" maxlength="255" disabled="true" /></div><br />';
$y += 4;
	}

}


// ###
echo '<div align="right"><a href="#top">To top of page</a></div><br />';


// end links


// begin files

echo '<img src="images/bpixel.gif" width="500" height="1" alt="- - -" /><br />
<a name="files"></a><span class="header3">Files</a></span><br /><br />';

//
// file handling.  if file records exist for paper, then display the data for that file; allow user to upload more.
//

$numRows = db_get_record_count_select('px_files', 'FileID', 'PaperID', $pid);

if ($numRows == 0) {
echo 'There are currently no files associated with this paper.  You may upload files <a href="files.php?action=add&pid=' . $pid . '">here</a>.<br /><br />';
}

else {
echo 'Found ' . $numRows . ' file(s) for this paper.  <a href="files.php?action=add&pid=' . $pid . '">Add More</a><br /><br />';
$sql = mysql_query("SELECT FileID, FileTitle, FileName, FileSize, FileType, DATE_FORMAT(DateAdded, '$date_time_short'), UploadedBy FROM px_files WHERE PaperID = '$pid' ORDER BY DateAdded DESC");
while ($row = mysql_fetch_row($sql)) {
echo '<span class="highlight">' . $row[1] . '</span> (added ' . $row[5] . ' by ' . $row[6] . ')<br />
Actions: <a href="files.php?action=viewinfo&fid=' . $row[0] . '">See More Details</a> | <a href="files.php?action=edit&fid=' . $row[0] . '">Edit</a> | <a href="files.php?action=delete&fid=' . $row[0] . '">Delete</a> | <a href="' . $dlurl . $row[2] . '">Download</a><br />
Information [name | size | type]: ' . $row[2] . ' | ' . parse_filesize($row[3]) . ' | ' . $row[4] . '<br /><br />';
}

}

echo '<strong>Warning!</strong> Before editing any files: if you have edited any data on this page, submit it first (via the button towards the bottom ofthe page), as clicking the link to add/modify/delete a file will take to another page and you may lose the modifications you have made here.<br /><br />';

echo '<div align="right"><a href="#top">To top of page</a></div><br /><br />';

// end files


echo '<input type="checkbox" name="dflag" value="d00" onclick="document.paper.dflag_confirm.disabled = !document.paper.dflag_confirm.disabled"> Check to delete this record;<br />
<input type="checkbox" name="dflag_confirm" value="d01" disabled="true"  onclick="extracheck(this)"> Please check this to <em>confirm</em> that you would like to delete this record.<br />
<strong>Warning!  Advertissement!  Warnung!</strong><br />  Deleting this record is <strong>irreversible</strong>.  All data - discussions, files and otherwise - associated with this record will be deleted.<br /><br />

<input type="submit" name="edit_paper" value="Edit Paper" />
<input type="reset" name="clear" value="Reset" />
</form>';
}
//
// End edit function
//

//
// Otherwise, display selection of papers that user is able to edit
//

else {
echo 'Please select a paper to edit.<br /><br />
<img src="images/bpixel.gif" width="300" height="1" alt="- - -" /><br /><br />
';

//
// Switch page depending on the user's permissions
//
switch ($page) {
    case 'admin':
        //
		// If the user is an adminstrator, display all records
		//
		$sql = mysql_query("SELECT PaperID, PaperTitle, SubmittedBy, DATE_FORMAT(DateSubmitted, '$date_time_full') FROM $table ORDER BY DateSubmitted DESC");

		$x = 1;

		while ($row = mysql_fetch_row($sql)) {
		$title = truncate($row[1], 60);

        echo '[' . $x . '] <a href="edit.php?pid=' . $row[0] . '">' . $title . '</a><br />
		Submitted By: ' . $row[2] . ' on ' . $row[3] . '<br /><br />
		';

		$x++;
		}
		
		break;


    case 'user':
		//
		// If the user is a normal user, display only the papers that the user has created
		//
		$user = $_SESSION['username'];
		$sql = mysql_query("SELECT PaperID, PaperTitle, SubmittedBy, DATE_FORMAT(DateSubmitted, '$date_time_full')FROM $table WHERE SubmittedBy = '$user' ORDER BY DateSubmitted DESC");

		$x = 1;

		while ($row = mysql_fetch_row($sql)) {
		$title = truncate($row[1], 60);

        echo '[' . $x . '] <a href="edit.php?pid=' . $row[0] . '">' . $title . '</a><br />
		Submitted By: ' . $row[2] . ' on ' . $row[3] . '<br /><br />
		';

		$x++;
		}
        break;
}
//
// end switch
//

}
//
// end else
//


include('includes/px_bottom.php');
?>
</div>

<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 


</td></tr></table>

</body>
</html>