<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
require('cfg/pagination_sort.php');
header("Pragma: no-cache");

$table = 'px_posts';

$login_flag = sess_check();

//
// functions specific to this page
// 
function preview_post($subject, $message) {
global $forum_date;

echo '<table class="post">
<tr id="theader">
	<td colspan="2">Preview Post</td>
</tr>
<tr id="row1">
	<td id="postLeft"><strong>' . $_SESSION['user'] .  '</strong></td>
	<td>
	
	<table>
	<tr>
	<td id="postInfo">'; 
	if($subject != '') { echo '<strong>Subject:</strong> ' . $subject . '<br />'; } 
	
	echo '
	posted on ' . date($forum_date) . '</td></tr>
	<tr><td>' .
	stripslashes(parse_html($message)) .
	'</td></tr></table>
	
	</td>
</tr>
</table><br /><br /><br />';
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Discussion</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js"></script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>
<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Discussion</div>

<?php
db_connect($dbhost, $dbuser, $dbpass);

//
// Check for log-in before displaying page;
// 
	if ($login_flag == 1) {
	//
	}
	else {
	echo 'You must be logged-in to make, edit or delete posts.';
	p_error();
	}

//
// use a switch on 'action' if specified
//
if(isset($_GET['action'])) {

	//
	// check for permissions to post first
	check_post_auth();


switch($_GET['action']) {

//
// make a new post to existing thread
//
	case 'post':
	if(!isset($_GET['tid']) || $_GET['tid'] == '') {
	echo 'No thread ID specified.';
	p_error();
	}
	else { $tid = $_GET['tid']; }
	
	validate_id($tid);
	$user = $_SESSION['user'];
	
	$sql = "SELECT Subject, PostCount FROM px_threads WHERE ThreadID = '$tid'";
	
	if(!$row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid thread ID specified.';
	p_error();
	}
	
	//
	// if user submits a new post
	//
	if(isset($_POST['postMessage'])) {
	
	$subject = trim(add_slashes($_POST['subject']));
	$message = trim(add_slashes($_POST['message']));
	if($message == '') { die('You must enter a message.  Please go back and enter one.'); }

	$count = $row[1] + 1;

	check_post_data($subject, $message);
	
	$sql = "INSERT INTO $table SET
	ThreadID = '$tid',
	Post = '$message',
	PostSubject = '$subject',
	Poster = '$user',
	PostTime = NOW()";

	if(@mysql_query($sql)) {
	$postID = mysql_insert_id();
	}
	else {
	echo 'Error occurred adding post.<br /><br />' . mysql_error(); '<br /><br />';
	p_error();
	}
	
	$sql = "UPDATE px_threads SET
	PostCount = '$count',
	LastPoster= '$user',
	LastPost = NOW() WHERE ThreadID = $tid";
	
	if(@mysql_query($sql)) {
	// continue
	}
	else {
	echo 'Error occurred adding post.<br /><br />' . mysql_error(); '<br /><br />';
	p_error();
	}
		
	db_increment_count('px_users', 'Username', $user, 'PostCount', 1);
	
	$page = ceil($count/$forum_per_page);
	
	echo 'Post succesfully added. <a href="discuss.php?action=view&tid=' . $tid . '&pg=' . $page . '#p' . $postID . '">View post</a> or <a href="discuss.php?action=view&tid=' . $tid . '">view thread</a>.';
	
	}
	
	//
	// form to make a new post
	//
	else {
	if(isset($_POST['previewpost'])) {
	preview_post($_POST['subject'], $_POST['message']);
	}

	//
	// get post to quote if the user requested it
	if(isset($_GET['replyto']) && !isset($_POST['previewpost'])) {
	$postID = $_GET['replyto'];
	validate_id($postID);
	
	$sql = mysql_query("SELECT Post, Poster, PostSubject from $table WHERE PostID = $postID");
	
	if(!$qdata = mysql_fetch_row($sql)) {
		$quote = 'Error in getting post to quote.';
		}	
	else {
		$search = array('/\n(\w+)/', '/^(\w+)/', '/\[\/quote\](\w+)/');
		$replace = array("\n\"\\1", '"\\1', '[/quote]"\\1');
		$quote = '[quote]Quoting <strong>' . $qdata[1] . '</strong>:
' . preg_replace($search, $replace, $qdata[0]) . '"[/quote]';
		}
	}
	
	echo '<div align="right"><a href="discuss.php?action=view&tid=' . $tid . '"><img src="images/forum_view_thread.gif" alt="View Thread" title="Click to view thread" border="0" /></a><br />
	<form name="newPost" action="post.php?action=post&tid=' . $tid . '" method="POST" onsubmit="return checkPostForm(-1)">
	<table class="post">
	<tr id="theader">
		<td colspan="2">Post Reply to topic \'' . $row[0] .'\'</td>
	</tr>
	<tr id="row1">
		<td>Subject:</td>
		<td><input type="text" name="subject" size="50" maxlength="60" class="msgbox" value="'; 
		if(isset($_POST['subject'])) { 
		echo stripslashes($_POST['subject']); } 
		elseif(isset($_GET['replyto'])) {
		echo 'RE: ' . $qdata[2]; }		
		else { echo 'RE: ' . $row[0]; }
		
		echo '" /></td>
	</tr>
	<tr id="row2">
		<td>Message:</td>
		<td><textarea name="message" rows="10" cols="70" class="msgbox">'; 
		
		if(isset($_POST['message'])) { echo stripslashes($_POST['message']); } 
		if(isset($quote)) {
		echo $quote;
		}
		echo '</textarea></td>
	</tr>
	<tr id="row1">
		<td>Poster:</td>
		<td>' . $user . '</td>
	</tr>
	<tr id="row2">
		<td>Options:</td>
		<td>The following HTML tags are allowed in the message: ' .  allowed_html() . '</td>
	</tr>
	</table>
	<input type="hidden" value="' . $tid . '" name="tid" />
	<input type="submit" name="postMessage" value="Post" /> <input type="submit" name="previewpost" value="Preview Post" />
	</form>
	';
	}
	break;

//
// edit an existing post
//
	case 'edit':
	if(!isset($_GET['pid'])) {
	echo 'No post ID specified.';
	p_error();
	}
	else {
	$pid = $_GET['pid'];
	}
	validate_id($pid);
	
	//
	// first, assure the post is valid...
	//
	$sql = mysql_query("SELECT Post, PostSubject, Poster, ThreadID FROM $table WHERE PostID = $pid");
	
	if(!$pdata = mysql_fetch_row($sql)) {
	echo 'Invalid post ID specified.';
	p_error();
	}
 
 	$tid = $pdata[3];
 
 	//
	// get thread data - to increment count if post will be deleted and to delete corresponding posts IF user chooses to delete the initial post of a thread.
 
 	$sql = mysql_query("SELECT InitPostID, PostCount, PaperID FROM px_threads WHERE ThreadID = $tid");
 
 	if(!$tdata = mysql_fetch_row($sql)) {
	echo 'Invalid thread specified.';
	p_error();
	}
	
	$initPID = $tdata[0];
	$count = $tdata[1];
 	$paperID = $tdata[2];
 
	//
	// and then authenticate
	//
	$user = $_SESSION['user'];
	
	if($user != $pdata[2]) {
		if($_SESSION['permissions'][0] < 1) {
		echo 'You are not authorized to edit this post.  Only administrators and the user who originally created the post are able to edit the post.';
		p_error();
		}
	}

	//
	// edit the post if the user has requested it
	//	
	if(isset($_POST['editPost'])) {

	// if delete flags are set...
	if(isset($_POST['dflag']) && isset($_POST['dflag_confirm']) && $_POST['dflag'] == 'd00' && $_POST['dflag_confirm'] == 'd01') {
		// if the paper is the initial post of a thread, delete the thread and the posts associated with it;
		if ($initPID == $pid) {
		
		// delete thread
		$sql = "DELETE FROM px_threads WHERE ThreadID = '$tid'";
		if(!mysql_query($sql)) {
		echo 'Error deleting thread.';
		p_error();
			}
		
		// delete posts from posts table
		$sql = "DELETE FROM $table WHERE ThreadID = '$tid'";
		if(!mysql_query($sql)) {
		echo 'Error deleting thread posts.';
		p_error();
			}

		db_increment_count('px_users', 'Username', $user, 'PostCount', -1);
		echo 'Thread successfully deleted.  <a href="browse.php?action=view&pid=' . $paperID . '">Back to the paper page</a> or <a href="discuss.php">go to the discussion page</a>.';
		}
		
		// otherwise, just delete the post 		
		else {

		$sql = "DELETE FROM $table WHERE PostID = $pid";

		if(mysql_query($sql)) {
		// increment post counts
		db_increment_count('px_threads', 'ThreadID', $tid, 'PostCount', -1);
		db_increment_count('px_users', 'Username', $user, 'PostCount', -1);
		echo 'Post successfully deleted.  <a href="discuss.php?action=view&tid=' . $tid . '">Go back</a> to the thread.';
			}
		}
	}
	
	// otherwise, edit the paper
	else {
	$subject = trim(add_slashes($_POST['subject']));
	$message = trim(add_slashes($_POST['message']));

	$message .= '
[small]Edited by ' . $user . ' on ' . date($date_time_short_php) . '[/small]';
		
	if($message == '') { die('You must enter a message.  Please go back and enter one.'); }	
	check_post_data($subject, $message);
	
	$sql = "UPDATE $table SET 
	Post = '$message',
	PostSubject = '$subject',
	PostEdit = NOW()
	WHERE PostID = $pid";
	
	if(!mysql_query($sql)) {
	echo 'Error editing the post.' . mysql_error();
		}
	else {
		echo 'Post successfully edited. <a href="discuss.php?action=view&tid=' . $tid . '">View thread</a>.';
				}	
			}
		}
	//
	// otherwise display the form!
	//
	else {
	if(isset($_POST['previewpost'])) {
	preview_post($_POST['subject'], $_POST['message']);
	}
	
	echo '<form name="newPost" action="post.php?action=edit&pid=' . $pid . '" method="POST" onsubmit="return checkPostForm(-1)">
	<table class="post">
	<tr id="theader">
		<td colspan="2">Edit Post: ' . $pdata[1]. '</td>
	</tr>
	<tr id="row1">
		<td>Subject:</td>
		<td><input type="text" name="subject" size="50" maxlength="60" class="msgbox" value="'; 
		if(isset($_POST['subject'])) { echo stripslashes($_POST['subject']); } 
		else { echo $pdata[1]; }
		echo '" /></td>
	</tr>
	<tr id="row2">
		<td>Message:</td>
		<td><textarea name="message" rows="10" cols="70" class="msgbox">';
		if(isset($_POST['message'])) { echo stripslashes($_POST['message']); }
		else { echo $pdata[0]; }
		echo '</textarea></td>
	</tr>
	<tr id="row1">
		<td>Poster:</td>
		<td>' . $pdata[2] . '</td>
	</tr>
	<tr id="row2">
		<td>Options:</td>
		<td>
		<input type="checkbox" name="dflag" value="d00" onclick="document.newPost.dflag_confirm.disabled = !document.newPost.dflag_confirm.disabled"> Check to <strong>delete</strong> this post.<br />
		<input type="checkbox" name="dflag_confirm" value="d01" disabled="true"  onclick="extracheck(this)"> Please check this to <em>confirm</em> that you would like to delete this post.<br /><br />';
		
		if ($initPID == $pid) {
		echo '<b>Warning:</b> This post is the initial post of a thread.  If you delete this post, then all posts in the thread started by this post will be deleted.<br /><br />';
		}
		
		echo 'The following HTML tags are allowed in the message: ' .  allowed_html() . '</td>
	</tr>
	</table>
	<input type="submit" name="editPost" value="Edit Post" /> <input type="submit" name="previewpost" value="Preview Post" />
	</form>';
	}
	break;
	
//
// make a new thread
//	
	case 'thread':
	// 
	// confirm that PID has been specified
	if(!isset($_POST['pid']) || $_POST['pid'] == '') {
	$p_flag1 = -1;
	}
	else { $pid = $_POST['pid']; }
	
	if(!isset($_GET['pid']) || $_GET['pid'] == '') {
	$p_flag2 = -1;
	}
	else { $pid = $_GET['pid']; }

	if(isset($p_flag1) && isset($p_flag2)) {
	echo 'No paper ID specified.';
	p_error();
	}
	
	validate_id($pid);

	//
	// assure that the paper ID is valid
	if(!mysql_query("SELECT DateSubmitted FROM px_papers WHERE PaperID = '$pid'")) {
	echo 'Invalid Paper ID specified.';
	p_error();
	}

	//
	//
	$user = $_SESSION['user'];

	//
	// ! if the user has submitted data, submit it after another round of verifications [above]
	//
	if(isset($_POST['postThread'])) {
	
	$subject = trim(add_slashes($_POST['subject']));
	$message = trim(add_slashes($_POST['message']));
	
	if($subject == '') { die('You must enter a subject.  Please go back and enter one.'); }
	if($message == '') { die('You must enter a message.  Please go back and enter one.'); }

	check_post_data($subject, $message);
	
	$sql = "INSERT INTO px_threads SET
	PaperID = '$pid',
	LastPost = NOW(),
	LastPoster = '$user',
	Subject = '$subject',
	PostCount = '1'";
	
	if(!mysql_query($sql)) {
	echo 'Error occurred in updating threads table.<br /><br />' . mysql_error() . '<br /><br />';
	p_error();
	}
	
	$tid = mysql_insert_id();
	
	// add the post to the posts table first
	$sql = "INSERT INTO $table SET
	ThreadID = '$tid',
	Poster = '$user',
	PostSubject = '$subject',
	Post = '$message',
	PostTime = NOW();
	";
	
	if(!mysql_query($sql)) {
	echo 'Error occurred in updating the posts table.<br /><br />'. mysql_error() . '<br /><br />';
	p_error();
	}
		
	$postID = mysql_insert_id();

	$sql = "UPDATE px_threads SET
	InitPostID = '$postID' WHERE ThreadID = '$tid'";
		
	if(!mysql_query($sql)) {
	echo 'Error occurred in updating threads table.<br /><br />' . mysql_error() . '<br /><br />';
	p_error();
		}
	
	// increment post count
	db_increment_count('px_users', 'Username', $user, 'PostCount', 1);
	
	echo 'Thread successfully posted.  <a href="discuss.php?action=view&tid=' . $tid . '">View the thread</a> or <a href="browse.php?action=view&pid=' . $pid . '">go back</a> to the paper record.';
	
	}
	
	// if all of the checks are okay, then display the form to add a thread:
	else {
	
	if(isset($_POST['previewpost'])) {
	preview_post($_POST['subject'], $_POST['message']);
	}
	
	echo '<form name="newPost" action="post.php?action=thread" method="POST" onsubmit="return checkPostForm(1)">
	<table class="post">
	<tr id="theader">
		<td colspan="2">Post New Thread</td>
	</tr>
	<tr id="row1">
		<td>Subject:</td>
		<td><input type="text" name="subject" size="50" maxlength="60" class="msgbox" value="'; if(isset($_POST['subject'])) { echo stripslashes($_POST['subject']); } echo '" /></td>
	</tr>
	<tr id="row2">
		<td>Message:</td>
		<td><textarea name="message" rows="10" cols="70" class="msgbox">'; if(isset($_POST['message'])) { echo stripslashes($_POST['message']); } echo '</textarea></td>
	</tr>
	<tr id="row1">
		<td>Poster:</td>
		<td>' . $user . '</td>
	</tr>
	<tr id="row2">
		<td>Options:</td>
		<td>The following HTML tags are allowed in the message: ' .  allowed_html() . '</td>
	</tr>
	</table>
	<input type="hidden" value="' . $pid . '" name="pid" />
	<input type="submit" name="postThread" value="Post Thread" /> <input type="submit" name="previewpost" value="Preview Post" />
	</form>
	';
	}
	
	break;
	}
// end switch
}
// end if

//
// otherwise display the error message:
//
else {

echo 'No action specified.';

}
// end else

include('includes/px_bottom.php');
?>
</div>

<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 

</td></tr></table>

</body>
</html>