<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
require('cfg/pagination_sort.php');

$table = 'px_papers';

$login_flag = sess_check();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Search</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js">
</script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>

<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Search</div>

<?php
db_connect($dbhost, $dbuser, $dbpass);


//
// browse papers
//

if(isset($_GET['type'])) {

switch($_GET['type']) {

	case 'paper':
	// get variables first!
	if(!isset($_GET['pg'])) { $page = 1; }
	else { $page = trim($_GET['pg']); }

	if(isset($_POST['PaperField'])) { $sfield = trim($_POST['PaperField']); }
	elseif(isset($_GET['sf']) && $_GET['sf'] != '') { $sfield = trim($_GET['sf']); }	
	else { $sfield = 'Citation'; }
	
	if(isset($_POST['OrderBy'])) { $orderby = trim($_POST['OrderBy']); }
	elseif(isset($_GET['o']) && $_GET['o'] != '') { $orderby = trim($_GET['o']); }	
	else { $orderby = 'PaperTitle'; }
	
	if(isset($_POST['Sort'])) {	$sort = trim($_POST['Sort']); }
	elseif(isset($_GET['sort']) && $_GET['sort'] != "") { $sort = trim($_GET['sort']); }
	else { $sort = "DESC"; }

	if(isset($_POST['query']) && $_POST['query'] != '') { $query = trim(substr($_POST['query'], 0, 128)); }
	elseif(isset($_GET['q']) && $_GET['q'] != '') { $query = trim(substr($_GET['q'], 0, 128)); }
	else { echo 'Error - no query entered.'; p_error(); }

	validate_id($page);
	validate_alpha($sort);
	validate_alpha($orderby);
	validate_alpha($sfield);
	validate_query($query);	

	// check for records
		
	$sql = "SELECT PaperID FROM $table WHERE $sfield LIKE '%$query%'";
	$numRows = @mysql_num_rows(mysql_query($sql));
	$pvars = page_vars($numRows, $per_page, $page);

	// display data if there are records
	if ($numRows <= 0) {
	echo 'No papers found. <a href="search.php">Search again</a>.<br /><br /><br />';
	}
	
	else {
	echo 'Found ' . $numRows . ' paper(s).  Displaying papers ' . ($pvars['start']+1) . ' through ' . ($pvars['end']+1) . '.  || <a href="search.php">New Query</a><br /><br />';
	
	generate_navigation($pvars['num_pages'], $page, 'search.php?type=paper' . '&sf=' . $sfield . '&o=' . $orderby . '&sort=' . $sort . '&pg=' . $page . '&q=' . $query . '&');
	
	echo '<br /><br /><img src="images/bpixel.gif" width="450" height="1" alt="- - -" /><br /><br />';
		
	$sql = mysql_query("SELECT PaperID, PaperTitle, Citation, SubmittedBy, DATE_FORMAT(DateSubmitted, '$date_short') FROM $table WHERE $sfield LIKE '%$query%' ORDER BY $orderby $sort LIMIT " . $pvars['start'] . ", $per_page");
	
	while ($row = mysql_fetch_array($sql)) {
	echo '<strong>' . $row[1] . '</strong><br />' .
	$row[2] . '<br />
	<a href="browse.php?action=view&s=1&sf=' . $sfield . '&o=' . $orderby . '&sort=' . $sort . '&pg=' . $page . '&pid=' . $row[0] . '&query=' . $query . '">More Information</a> || Submitted by: ' . $row[3] . ' ' . $row[4] . '<br /><br />';
	}

	echo '<br /><img src="images/bpixel.gif" width="450" height="1" alt="- - -" /><br /><br />';
	}

	break;

	//
	// default
	default:
	echo 'No defined function specified.';
	break;
}

}

else {
//
// default action is to browse papers - display form for browsing
//

gen_search(NULL, NULL, NULL);
}

include('includes/px_bottom.php');
?>
</div>

<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 


</td></tr></table>

</body>
</html>