<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
header("Pragma: no-cache");

$table = 'px_files';

$login_flag = sess_check();

// 
// Allow user to download file if that function is specified, otherwise continue displaying the page
//
if(isset($_GET['action']) && $_GET['action'] == 'dl') {

if(isset($_GET['fid']) && $_GET['fid'] != '') {

$fid = $_GET['fid'];

db_connect($dbhost, $dbuser, $dbpass);
if(@$row = mysql_fetch_row(mysql_query("SELECT FileName FROM $table WHERE FileID = '$fid'"))) {
// $row = mysql_fetch_row($sql);

// increment download counter
db_increment_count('px_files', 'FileID', $fid, 'DownloadCount', 1);

// redirect user to download file
header ('Location: ' . $dlurl . $row[0]);
	}

else {
// Error!
echo 'Invalid file specified.';
	}

}
}

// 
// Rest of Page

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Files</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js">
</script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>

<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Files</div>

<?php

//
// Check to see that action is set
//
if(!isset($_GET['action'])) {
echo 'No action specified.';
p_error();
}
else {
	//
	// check if user is logged-in
	if ($login_flag != 1) {
	p_error();
	}
//
// Switch page depending on the action specified
//
db_connect($dbhost, $dbuser, $dbpass);

switch ($_GET['action']) {

//
// Allow user to upload a file
//
    case 'add':
	//
	// Display form to upload file
	//
		
	//
	// check for paper ID
	if (!isset($_GET['pid']) or  $_GET['pid'] == '') {
	echo 'No paper specified.';
	p_error();
	}
	else {
	// validate it if present
	$pid = $_GET['pid'];
	validate_id($pid);
	}

	// get data for form / page - this verifies if there is a paper with the specified PID; otherwise the error is displayed and the script quits
	$sql = "SELECT PaperTitle, SubmittedBy FROM px_papers WHERE PaperID = '$pid'";
	if(!$row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid paper ID specified.';
	p_error();
	} 
	
	// check user authorization
	papers_auth($row[1]);

	// Continue
	// Display the form
	echo 'Add file for paper with title \'' .  $row[0] . '\'.<br />(Or <a href="edit.php?pid=' . $pid . '">go back</a> to the edit paper page.)<br /><br />
	<strong>Instructions &amp; Notes [Important!  Importante!  Wichtig!]:</strong><br />
	<ul>
	<li>Assure that the file you are uploading has a Unix-compatible file name;</li>
	<li>The file name length, extension included, should be less than 255 characters;</li>
	<li>Only certain files of certain types will be allowed to be uploaded to this server, and the file must be named with the corresponding extension (i.e. the extension must be \'.doc\' if the file is a Microsoft Word file).  This restriction is due to the way the file\'s type is sent to the server.  Please see <a href="help.php?section=file&area=types">this link</a> for a list of permitted file types before uploading the file.</li>
	</ul>
	<br />
	<form enctype="multipart/form-data" action="files.php?action=upload" method="POST">
	<input type="hidden" name="MAX_FILE_SIZE" value="52428800">
	<input type="hidden" name="pid" value="' . $pid . '">
	File to Upload:<br />
	<input name="userfile" type="file"><br /><br />
	<input type="submit" value="Upload File"></span>
	</form>';
	break;



//
// Allow user to edit a file's record
//
    case 'edit':
	@$fid = $_GET['fid'];
	validate_id($fid);
	
	// get data from files table first
	$sql = "SELECT UploadedBy, Note, PaperID FROM $table WHERE FileID = '$fid'";
	if(!$file_row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid file ID specified.';
	p_error();
	}

	// make sure whether the person who is requestnig the edit created the paper record, or is an administrator
	papers_auth($file_row[0]);


	//
	// update the record if user requested it
	//
	if(isset($_POST['editFlag'])) {

	$filenote = substr(trim($_POST['fileNote']), 0, 254);

	$sql = "UPDATE $table SET Note = '$filenote' WHERE FileID = $fid";

	if(mysql_query($sql)) {
		echo 'Note successfully added.  <a href="files.php?action=edit&fid=' . $fid . '">Edit file again</a> or <a href="edit.php?pid=' . $file_row[2] . '">go back to</a> editing the paper</a>.';
		}
	else {
		echo 'Error updating the database.';
		}
	}

	//
	// otherwise, display the edit form
	//

	else {
	echo 'You may add a short note (maximum: 255 characters) to attach to the file.<br />
	(Or <a href="edit.php?pid=' . $file_row[2] . '">go back to</a> editing the paper.)</a><br /><br />
	<form name="editFile" action="files.php?action=edit&fid=' . $fid . '" method="POST">
	<textarea cols="35" rows="5" name="fileNote">' . $file_row[1] . '</textarea><br />
	<input type="submit" value="Edit" name="editFlag">';
	
	}
	
	break;



//
// Allow user to delete a file
//
	case 'delete':
	@$fid = $_GET['fid'];
	validate_id($fid);
	
	// get data from files table first
	$sql = "SELECT FileName, UploadedBy, PaperID FROM $table WHERE FileID = '$fid'";
	if(!$file_row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid file ID specified.';
	p_error();
	}

	$pid = $file_row[2];

	// make sure the person who uploaded the file is deleting it, or if it is an administrator
	papers_auth($file_row[1]);
	
	// get data for form / page - this verifies if there is a paper with the specified PID; otherwise the error is displayed and the script quits
	$sql = "SELECT PaperTitle, SubmittedBy FROM px_papers WHERE PaperID = '$pid'";
	if(!$row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid paper ID specified.';
	p_error();
	} 
	
	// check user authorization
	papers_auth($row[1]);


	// delete the file if the user has requested file deletion
	if(isset($_POST['delete'])) {

	if(!@unlink($uploaddir . $file_row[0])) {
	echo 'Error deleting file.  Please contact an administrator with this information:<br />
	FileID: ' . $fid . '<br />
	File Name: ' . $file_row[0] . '<br />';
	p_error();
	}

	$sql = "DELETE FROM $table WHERE FileID = '$fid'";

	if(!mysql_query($sql)) {
	echo 'Error occurred deleting data from the database.  Please contact an administrator with this information:<br />
	FileID: ' . $fid . '<br />
	File Name: ' . $file_row[0] . '<br />';
	p_error();
	}
	
	echo 'File successfully deleted. <a href="edit.php?pid=' . $pid . '">Go back</a> to the edit paper page.</a>';
	
	}


	// display confirmation message
	else {
	echo 'Are you sure that you would like to delete the file \'' . $file_row[0] . '\' from record for the paper \'' . $row[0] . '\'?  This will be <strong>permanent</strong> and all data associated with the file will be destoyed.<br /><br />
	<form action="files.php?action=delete&fid=' . $fid . '" method="POST"><input type="submit" value="Delete this File" name="delete"><input type="button" value="Cancel" onclick="javascript:location.href=\'edit.php?pid=' . $pid .'\'"></form>';
	}

	break;

//
// The upload function
//
	case 'upload':
	@$pid = $_POST['pid'];
	validate_id($pid);
	
	// get data for form / page - this verifies if there is a paper with the specified PID; otherwise the error is displayed and the script quits
	$sql = "SELECT PaperTitle, SubmittedBy FROM px_papers WHERE PaperID = '$pid'";
	if(!$row = mysql_fetch_row(mysql_query($sql))) {
	echo 'Invalid paper ID specified.';
	p_error();
	} 
	
	$current_user = $_SESSION['user'];
	
	// check user authorization
	papers_auth($row[1]);
	
	// ###########################
	// Upload functions!
	//
	$orig_name = $_FILES['userfile']['name'];
	$ext = strrchr($orig_name, ".");
	
	// check for file extension
	if(!strpos($orig_name, '.')) {
	echo 'Error - file with no extension uploaded.';
	p_error();
	}

	//
	// if the file exists already, append an underscore and number to it	
	if(file_exists($uploaddir . $orig_name)) {

	// get the first part of the file name
	$string = $orig_name;
	$offset = 0;
	$len = strlen($orig_name);
	$total = 0;
	
	while (strpos($string, '.')) {
	
	$pos = strpos($string, '.');
	$offset = $pos+1;

	$string = substr($string, $offset, $len);
	
	$total += $offset;
		}

	$name = substr($orig_name, 0, $total-1);
	
	// generate new name
	$newname = $name . '_0' . $ext;
	
	// keep numbering until unique filename is created
	while(file_exists($uploaddir . $newname)) {
	$x = 1;
	$newname = $name . '_' . $x . $ext;
	$x++;
		}
	
	}

	//
	// otherwise, keep the original name
	else {
	$newname = $orig_name;
	}
	
	//
	// check for file types!
	//
	
	// Allowed file types!
	$allowedfile['jpg'] = 'image/jpeg';							/* JPEG image file (.jpg) */
	$allowedfile['jpeg'] = 'image/jpeg';						/* JPEG image file (.jpeg) */
	$allowedfile['jpe'] = 'image/jpeg';							/* JPEG image file (.jpe) */
	$allowedfile['gif'] = 'image/gif';							/* GIF image file */
	$allowedfile['png'] = 'image/png';							/* PNG image file */
	$allowedfile['tif'] = 'image/tif';							/* TIFF image file (.tif) */
	$allowedfile['tiff'] = 'image/tiff';						/* TIFF image file (.tiff) */
	$allowedfile['html'] = 'text/html';							/* HTML file (.html) */
	$allowedfile['htm'] = 'text/html';							/* HTML file (.htm) */
	$allowedfile['css'] = 'text/css';							/* CSS file (.css) */
	$allowedfile['xml'] = 'text/xml';							/* XML file (.xml) */
	$allowedfile['txt'] = 'text/plain';							/* Regular text file */
	$allowedfile['doc'] = 'application/msword';					/* MS Word document */
	$allowedfile['rtf'] = 'application/rtf';					/* RTF document */
	$allowedfile['pdf'] = 'application/pdf';					/* PDF document */
	$allowedfile['pot'] = 'application/mspowerpoint';			/* MS PowerPoint document (.pot) */
	$allowedfile['pps'] = 'application/mspowerpoint';			/* MS PowerPoint document (.pps) */
	$allowedfile['ppt'] = 'application/mspowerpoint';			/* MS PowerPoint document (.ppt) */
	$allowedfile['ppz'] = 'application/mspowerpoint';			/* MS PowerPoint document (.ppz) */
	$allowedfile['xls'] = 'application/x-excel';				/* MS Excel document */
	$allowedfile['zip'] = 'application/zip';					/* ZIP file */
	$allowedfile['tar'] = 'application/x-tar';					/* Tarred files */
	$allowedfile['gz'] = 'application/x-gzip';					/* Gzipped files */
	$allowedAlternate['jpg'] = 'image/pjpeg';					/* JPEG image file alternate (.jpg) */
	$allowedAlternate['jpeg'] = 'image/pjpeg';					/* JPEG image file alternate (.jpeg) */
	$allowedAlternate['jpe'] = 'image/pjpeg';					/* JPEG image file alternate (.jpe) */
	$allowedAlternate['png'] = 'image/x-png';					/* PNG image file alternate. */
	$allowedAlternate['zip'] = 'application/x-zip-compressed';	/* ZIP file alternate */
	
	// define file type
	$ftype = $_FILES['userfile']['type'];
	
	if(@$allowedfile[substr($ext, 1, 10)] == $ftype) {
	// proceed
	}
	elseif(@$allowedAlternate[substr($ext, 1, 10)] == $ftype) {
	//proceed
	}
	else {
	echo 'You may not upload a file of type ' . $ftype;
	p_error();
	}
	
	// and finally, move the file!
	if (move_uploaded_file($_FILES['userfile']['tmp_name'], $uploaddir . $newname)) {

	
	$fsize = $_FILES['userfile']['size'];
	
	$sql = "INSERT INTO $table SET PaperID = '$pid', FileName = '$newname', FileTitle = '$newname', FileSize = '$fsize', FileType = '$ftype', DateAdded = NOW(), UploadedBy = '$current_user'";

	if(@mysql_query($sql)) {
	echo 'The file was successfully uploaded.  Information:<br />
	File name: ' . $newname . '<br />
	File type: ' . $ftype . '<br />
	File size: ' . parse_filesize($fsize) . '<br /><br />
	
	| <a href="files.php?action=add&pid=' . $pid . '">Add another file</a> | 
	<a href="edit.php?pid=' . $pid . '">Back to edit paper page</a> |';
    }
	
	else {
		echo 'MySQL Error.<br /><br />' . mysql_error();
		unlink($uploaddir . $newname);
		}
	}

	else {
    print 'Error:<br /><br />';
    print_r($_FILES);
	}

	break;
	
//
// get detailed information on the file
//
	case 'viewinfo':
	if (!isset($_GET['fid'])) {
	echo 'No file ID specified.';
	p_error();
	}
	else {
	$fid = $_GET['fid'];
	validate_id($fid);
	}

	$sql = mysql_query("SELECT FileID, FileTitle, FileName, FileSize, FileType, DATE_FORMAT(DateAdded, '$date_short'), UploadedBy, Note, DownloadCount, PaperID FROM px_files WHERE FileID = '$fid'");
	while ($row = mysql_fetch_row($sql)) {

	echo '<a href="browse.php?action=view&pid=' . $row[9] . '">Paper</a> &gt; File: ' . $row[2] . '<br /><br />
	<span class="subheader">File Information: ' . $row[2] . ' </span><br /><br />
	<table border="0" cellspacing="0" cellpadding="3">
	<tr>
	<td><strong>File Name:</strong></td>
	<td>' . $row[2] . '</td>
	</tr>
	<tr>
	<td><strong>File Title:</strong></td>
	<td>' . $row[1] . '</td>
	</tr>
	<tr>
	<td><strong>File Type (MIME):</strong></td>
	<td>' . $row[4] . '</td>
	</tr>
	<tr>
	<td><strong>File Size:</strong></td>
	<td>' . parse_filesize($row[3]) . '</td>
	</tr>
	<tr>
	<td><strong>Date Added:</strong></td>
	<td>' . $row[5] . '</td>
	</tr>
	<tr>
	<td><strong>Added by:</strong></td>
	<td>' . $row[6] . '</td>
	</tr>
	<tr>
	<td><strong>Downloads</strong></td>
	<td>' . $row[8] . '</td>
	</tr>
	</table>';
	
	if($row[7] != '') {
	echo '<div style="margin-left: 30px; margin-top: 10px;"><strong>Notes:</strong><br /> ' . $row[7] . '</div><br />';
		}
	else {
		echo '<br />';	
		}
	}
	break;
	
	default:
	'Invalid action specified.';
	break;
}
// end switch

}
// end else

include('includes/px_bottom.php');

?>
</div>
<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 

</td></tr></table>

</body>
</html>